%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% This code demonstrate the usage of depth data reconstruction algorithm 
% (multiscale ADMM algorithm) using combined dictionary.    
%       
% Regarding the detailed information, please refer to our paper:
% Lee-Kang Liu, Stanley H. Chan and Truong Q. Nguyen, "Depth Reconstruction
% from Sparse Samples: Representation, Algorithm and Sampling"
%
% last modfied: 11/06/2014
% Lee-Kang (Lester) Liu and Stanley Chan
% Copyright 2014
% University of California, San Diego
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


close all
clear all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% access disparity data
c=cd('.\data\');
gt_x0  = im2double(imread('Aloe_disp1_512.png'));
x0 = gt_x0;
[rows cols] = size(x0);
cd(c);

    % defining the sampling rate
    sp = 0.1;
disp('--- Running Depth Reconstruction Algorithm ---');
disp(' Dictionary Type : Multiscale ADMM for Combined Dictionary ');
    
    % uniformly random sampling map generation
    %S        = (rand(rows, cols)<=sp);
    b        = S.*x0;
    
    % main algorithm for dense disparity reconstruction
   xout = ADMM_outer(S,b);
 
     
    MSE = mean(((xout(:)-x0(:)).^2));
    
 disp('--- Dense Disparity Map is Reconstructed ---');
 disp(sprintf(' (1). Percentage of uniformly random samples : %2.1f%% \n (2). Mean Square Error (MSE) is : %0.5g. ',100*sp,MSE));
